<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::set_kernel_1&lt; T, bst_base, mem_manager &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1set__kernel__1.html">set_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1set__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::set_kernel_1&lt; T, bst_base, mem_manager &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::set_kernel_1&lt; T, bst_base, mem_manager &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1set__kernel__1.png" usemap="#dlib::set_5Fkernel_5F1_3C_20T_2C_20bst_5Fbase_2C_20mem_5Fmanager_20_3E_map" alt=""/>
  <map id="dlib::set_5Fkernel_5F1_3C_20T_2C_20bst_5Fbase_2C_20mem_5Fmanager_20_3E_map" name="dlib::set_5Fkernel_5F1_3C_20T_2C_20bst_5Fbase_2C_20mem_5Fmanager_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; const T &gt;" shape="rect" coords="0,56,290,80"/>
<area href="classdlib_1_1asc__remover.html" alt="dlib::asc_remover&lt; T, bst_base::compare_type &gt;" shape="rect" coords="300,56,590,80"/>
<area href="classdlib_1_1remover.html" alt="dlib::remover&lt; T &gt;" shape="rect" coords="300,0,590,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:aca5a8c174ea7a5c27000bdfc5939c4eb"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#aca5a8c174ea7a5c27000bdfc5939c4eb">type</a></td></tr>
<tr class="separator:aca5a8c174ea7a5c27000bdfc5939c4eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5691546fbc77f355ee04d49477b7b400"><td class="memItemLeft" align="right" valign="top"><a id="a5691546fbc77f355ee04d49477b7b400"></a>
typedef bst_base::compare_type&#160;</td><td class="memItemRight" valign="bottom"><b>compare_type</b></td></tr>
<tr class="separator:a5691546fbc77f355ee04d49477b7b400"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6c877e5cbcddeaad8eeea26e026c602"><td class="memItemLeft" align="right" valign="top"><a id="af6c877e5cbcddeaad8eeea26e026c602"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:af6c877e5cbcddeaad8eeea26e026c602"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; const T &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef const T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1asc__remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1asc__remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1asc__remover.html">dlib::asc_remover&lt; T, bst_base::compare_type &gt;</a></td></tr>
<tr class="memitem:a1cdcf567148fe5d50a6d1b81c3c22828 inherit pub_types_classdlib_1_1asc__remover"><td class="memItemLeft" align="right" valign="top">typedef bst_base::compare_type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1asc__remover.html#a1cdcf567148fe5d50a6d1b81c3c22828">compare_type</a></td></tr>
<tr class="separator:a1cdcf567148fe5d50a6d1b81c3c22828 inherit pub_types_classdlib_1_1asc__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a717e9bdbd0335036d142080dbac7d66d">type</a></td></tr>
<tr class="separator:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a444182dfa7e6d95779d3669cecff8462"><td class="memItemLeft" align="right" valign="top"><a id="a444182dfa7e6d95779d3669cecff8462"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a444182dfa7e6d95779d3669cecff8462"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53c5ae646ba4b30e81f284993d9e6f3c"><td class="memItemLeft" align="right" valign="top"><a id="a53c5ae646ba4b30e81f284993d9e6f3c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>add</b> (T &amp;item)</td></tr>
<tr class="separator:a53c5ae646ba4b30e81f284993d9e6f3c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adfc21afbf687f8ba95ef2a2596189f2b"><td class="memItemLeft" align="right" valign="top"><a id="adfc21afbf687f8ba95ef2a2596189f2b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_member</b> (const T &amp;item) const</td></tr>
<tr class="separator:adfc21afbf687f8ba95ef2a2596189f2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a289d0e04ba9bb516f1bbc84a6af0e866"><td class="memItemLeft" align="right" valign="top"><a id="a289d0e04ba9bb516f1bbc84a6af0e866"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>remove</b> (const T &amp;item, T &amp;item_copy)</td></tr>
<tr class="separator:a289d0e04ba9bb516f1bbc84a6af0e866"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7af8a1fe5a42aeaae47f055e589a18bd"><td class="memItemLeft" align="right" valign="top"><a id="a7af8a1fe5a42aeaae47f055e589a18bd"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>destroy</b> (const T &amp;item)</td></tr>
<tr class="separator:a7af8a1fe5a42aeaae47f055e589a18bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7e56c0cd63f330ab80a4ceea0f314d84"><td class="memItemLeft" align="right" valign="top"><a id="a7e56c0cd63f330ab80a4ceea0f314d84"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1set__kernel__1.html">set_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a7e56c0cd63f330ab80a4ceea0f314d84"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6fc32dc1e346d6306201c0add9be9123"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#a6fc32dc1e346d6306201c0add9be9123">remove_any</a> (T &amp;item)</td></tr>
<tr class="separator:a6fc32dc1e346d6306201c0add9be9123"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad18e62483082b7743423871e6ffed8a7"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#ad18e62483082b7743423871e6ffed8a7">size</a> () const</td></tr>
<tr class="separator:ad18e62483082b7743423871e6ffed8a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a163d844e8e281a55b6d552c13c0c5d10"><td class="memItemLeft" align="right" valign="top"><a id="a163d844e8e281a55b6d552c13c0c5d10"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:a163d844e8e281a55b6d552c13c0c5d10"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71fef14010d1b7535d0c63f166e4bca0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#a71fef14010d1b7535d0c63f166e4bca0">reset</a> () const</td></tr>
<tr class="separator:a71fef14010d1b7535d0c63f166e4bca0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ddb7784be799544f48824ae50728518"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#a4ddb7784be799544f48824ae50728518">current_element_valid</a> () const</td></tr>
<tr class="separator:a4ddb7784be799544f48824ae50728518"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1b87d637a1c9af5dade9b3e3ff3792b"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#ac1b87d637a1c9af5dade9b3e3ff3792b">element</a> () const</td></tr>
<tr class="separator:ac1b87d637a1c9af5dade9b3e3ff3792b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2e0a11793ea61e5cbec33693cd61011"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#ac2e0a11793ea61e5cbec33693cd61011">element</a> ()</td></tr>
<tr class="separator:ac2e0a11793ea61e5cbec33693cd61011"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1b6ee12e3897ce5bd1e45aacc4a0426"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1set__kernel__1.html#af1b6ee12e3897ce5bd1e45aacc4a0426">move_next</a> () const</td></tr>
<tr class="separator:af1b6ee12e3897ce5bd1e45aacc4a0426"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:aa14e595907680800c7f0c2be344a448c"><td class="memItemLeft" align="right" valign="top"><a id="aa14e595907680800c7f0c2be344a448c"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>set_kernel_1</b> (<a class="el" href="classdlib_1_1set__kernel__1.html">set_kernel_1</a> &amp;)</td></tr>
<tr class="separator:aa14e595907680800c7f0c2be344a448c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af73c69ba23d404951332e51e4ce58124"><td class="memItemLeft" align="right" valign="top"><a id="af73c69ba23d404951332e51e4ce58124"></a>
<a class="el" href="classdlib_1_1set__kernel__1.html">set_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1set__kernel__1.html">set_kernel_1</a> &amp;)</td></tr>
<tr class="separator:af73c69ba23d404951332e51e4ce58124"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a8b198f0e99c102c56309d271b0ef932f"><td class="memItemLeft" align="right" valign="top"><a id="a8b198f0e99c102c56309d271b0ef932f"></a>
bst_base&#160;</td><td class="memItemRight" valign="bottom"><b>bst</b></td></tr>
<tr class="separator:a8b198f0e99c102c56309d271b0ef932f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ab58a442c7605b60b8e795df701497b"><td class="memItemLeft" align="right" valign="top"><a id="a7ab58a442c7605b60b8e795df701497b"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><b>junk</b></td></tr>
<tr class="separator:a7ab58a442c7605b60b8e795df701497b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; const T &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1asc__remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1asc__remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1asc__remover.html">dlib::asc_remover&lt; T, bst_base::compare_type &gt;</a></td></tr>
<tr class="memitem:a58a9b1fc66e5cd1412332fdc27fe700b inherit pro_methods_classdlib_1_1asc__remover"><td class="memItemLeft" align="right" valign="top"><a id="a58a9b1fc66e5cd1412332fdc27fe700b"></a>
<a class="el" href="classdlib_1_1asc__remover.html">asc_remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1asc__remover.html">asc_remover</a> &amp;)</td></tr>
<tr class="separator:a58a9b1fc66e5cd1412332fdc27fe700b inherit pro_methods_classdlib_1_1asc__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1remover.html">remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a58be6630e553c7f4d14dd4c4c2b4c859">operator=</a> (const <a class="el" href="classdlib_1_1remover.html">remover</a> &amp;)</td></tr>
<tr class="separator:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="aca5a8c174ea7a5c27000bdfc5939c4eb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca5a8c174ea7a5c27000bdfc5939c4eb">&#9670;&nbsp;</a></span>type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename bst_base, typename mem_manager = default_memory_manager&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef T <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::<a class="el" href="classdlib_1_1remover.html#a717e9bdbd0335036d142080dbac7d66d">type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON bst_base
    bst_base is instantiated with &lt;domain=T,range=char&gt; and
    implements binray_search_tree/binary_search_tree_kernel_abstract.h

INITIAL VALUE
    bst has its initial value

CONVENTION
    bst.size() == the number of elements in the set and
    the elements in the set are stored in bst
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a4ddb7784be799544f48824ae50728518"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4ddb7784be799544f48824ae50728518">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; const T &gt;</a>.</p>

</div>
</div>
<a id="ac2e0a11793ea61e5cbec33693cd61011"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac2e0a11793ea61e5cbec33693cd61011">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; const T &gt;</a>.</p>

</div>
</div>
<a id="ac1b87d637a1c9af5dade9b3e3ff3792b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac1b87d637a1c9af5dade9b3e3ff3792b">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; const T &gt;</a>.</p>

</div>
</div>
<a id="af1b6ee12e3897ce5bd1e45aacc4a0426"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af1b6ee12e3897ce5bd1e45aacc4a0426">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; const T &gt;</a>.</p>

</div>
</div>
<a id="a6fc32dc1e346d6306201c0add9be9123"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6fc32dc1e346d6306201c0add9be9123">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1remover.html#a80c7e7417e08a66ca361f646a12aaa03">dlib::remover&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a71fef14010d1b7535d0c63f166e4bca0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71fef14010d1b7535d0c63f166e4bca0">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; const T &gt;</a>.</p>

</div>
</div>
<a id="ad18e62483082b7743423871e6ffed8a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad18e62483082b7743423871e6ffed8a7">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename bst_base , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1set__kernel__1.html">dlib::set_kernel_1</a>&lt; T, bst_base, mem_manager &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; const T &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="set__kernel__1_8h_source.html">set_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
